/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20161210-64(RM)
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-13-NVSGPCH.aml, Wed Nov 22 15:47:56 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000030DE (12510)
 *     Revision         0x01
 *     Checksum         0x1E
 *     OEM ID           "HP"
 *     OEM Table ID     "NVSGPCH"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20160527 (538314023)
 */
DefinitionBlock ("", "SSDT", 1, "HP", "NVSGPCH", 0x00001000)
{
    /*
     * iASL Warning: There were 28 external control methods found during
     * disassembly, but only 27 were resolved (1 unresolved). Additional
     * ACPI tables may be required to properly disassemble the code. This
     * resulting disassembler output file may not compile because the
     * disassembler did not know how many arguments to assign to the
     * unresolved methods. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     *
     * To specify the tables needed to resolve external control method
     * references, the -e option can be used to specify the filenames.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_PR_.CPPC, IntObj)    // (from opcode)
    External (_PR_.HWPV, IntObj)    // (from opcode)
    External (_PR_.PR00._PPC, IntObj)    // (from opcode)
    External (_PR_.PR00._PSS, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.BCL_, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.BCM_, MethodObj)    // 1 Arguments (from opcode)
    External (_SB_.BEVT, EventObj)    // (from opcode)
    External (_SB_.BQC_, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.DCKD, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.F4EV, EventObj)    // (from opcode)
    External (_SB_.GGIV, MethodObj)    // 1 Arguments (from opcode)
    External (_SB_.GGOV, MethodObj)    // 1 Arguments (from opcode)
    External (_SB_.LID_._LID, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.ODGW, MethodObj)    // 1 Arguments (from opcode)
    External (_SB_.PCI0, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.GFX0.GVID, FieldUnitObj)    // (from opcode)
    External (_SB_.PCI0.GFX0.ISBR, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.HGMD, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.LPCB.EC0_.ADP_, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.EC0_.CRZN, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.EC0_.DTMP, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.EC0_.ECMX, MutexObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.EC0_.ECRG, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.EC0_.EXTP, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.EC0_.GACS, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.LPCB.EC0_.GPID, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.LPCB.EC0_.TENA, FieldUnitObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.EC0_.UDTS, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.RP01, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP01._ADR, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.RP01.PXSX, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP01.PXSX._ADR, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP01.PXSX.DEDP, IntObj)    // (from opcode)
    External (_SB_.PCI0.RP01.PXSX.DGCX, FieldUnitObj)    // (from opcode)
    External (_SB_.PCI0.RP01.PXSX.DODI, BuffObj)    // (from opcode)
    External (_SB_.PCI0.RP01.PXSX.DODS, PkgObj)    // (from opcode)
    External (_SB_.PCI0.RP01.PXSX.GDCC, MethodObj)    // 1 Arguments (from opcode)
    External (_SB_.PCI0.RP01.PXSX.LNHV, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.RP01.PXSX.MDSM, MethodObj)    // 4 Arguments (from opcode)
    External (_SB_.PCI0.RP01.PXSX.MDTL, PkgObj)    // (from opcode)
    External (_SB_.PCI0.RP01.PXSX.NDOD, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.RP01.PXSX.NPLH, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.RP01.PXSX.PDOS, MethodObj)    // 2 Arguments (from opcode)
    External (_SB_.PCI0.RP01.PXSX.PNOT, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.RP01.PXSX.RDSS, MethodObj)    // 1 Arguments (from opcode)
    External (_SB_.PCI0.RP01.PXSX.TDGC, FieldUnitObj)    // (from opcode)
    External (_SB_.SBRC, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.SGOV, MethodObj)    // 2 Arguments (from opcode)
    External (ASGM, UnknownObj)    // (from opcode)
    External (BCCT, FieldUnitObj)    // (from opcode)
    External (BCLV, BuffObj)    // (from opcode)
    External (BMAP, BuffObj)    // (from opcode)
    External (BRCT, FieldUnitObj)    // (from opcode)
    External (BRID, FieldUnitObj)    // (from opcode)
    External (BRLV, BuffObj)    // (from opcode)
    External (BRNT, BuffObj)    // (from opcode)
    External (DCAP, FieldUnitObj)    // (from opcode)
    External (DEDP, IntObj)    // Warning: Unknown object
    External (DID1, FieldUnitObj)    // (from opcode)
    External (DLHR, UnknownObj)    // (from opcode)
    External (DLPW, UnknownObj)    // (from opcode)
    External (DODI, IntObj)    // Warning: Unknown object
    External (DODS, UnknownObj)    // Warning: Unknown object
    External (EECP, UnknownObj)    // (from opcode)
    External (GBAS, UnknownObj)    // (from opcode)
    External (GC6A, FieldUnitObj)    // (from opcode)
    External (GC6E, FieldUnitObj)    // (from opcode)
    External (GC6G, FieldUnitObj)    // (from opcode)
    External (GDCC, UnknownObj)    // Warning: Unknown object
    External (GDP1, FieldUnitObj)    // (from opcode)
    External (GDP2, FieldUnitObj)    // (from opcode)
    External (GDP3, FieldUnitObj)    // (from opcode)
    External (GDP4, FieldUnitObj)    // (from opcode)
    External (GETA, FieldUnitObj)    // (from opcode)
    External (GETE, FieldUnitObj)    // (from opcode)
    External (GETG, FieldUnitObj)    // (from opcode)
    External (GTOS, MethodObj)    // 0 Arguments (from opcode)
    External (HGD2, FieldUnitObj)    // (from opcode)
    External (HGDG, FieldUnitObj)    // (from opcode)
    External (HRA0, UnknownObj)    // (from opcode)
    External (HRE0, UnknownObj)    // (from opcode)
    External (HRG0, UnknownObj)    // (from opcode)
    External (ILUX, FieldUnitObj)    // (from opcode)
    External (MDSM, IntObj)    // Warning: Unknown object
    External (MDTL, IntObj)    // Warning: Unknown object
    External (NDOD, IntObj)    // Warning: Unknown object
    External (NDXN, FieldUnitObj)    // (from opcode)
    External (NSOR, FieldUnitObj)    // (from opcode)
    External (OSYS, UnknownObj)    // (from opcode)
    External (PNOT, MethodObj)    // Warning: Unknown method, guessing 0 arguments
    External (PWA0, UnknownObj)    // (from opcode)
    External (PWE0, UnknownObj)    // (from opcode)
    External (PWG0, UnknownObj)    // (from opcode)
    External (RPA1, UnknownObj)    // (from opcode)
    External (SDTA, FieldUnitObj)    // (from opcode)
    External (SDTE, FieldUnitObj)    // (from opcode)
    External (SDTG, FieldUnitObj)    // (from opcode)
    External (SGGP, UnknownObj)    // (from opcode)
    External (SGMD, UnknownObj)    // (from opcode)
    External (SRCP, MethodObj)    // 2 Arguments (from opcode)
    External (VACC, FieldUnitObj)    // (from opcode)
    External (VRMB, FieldUnitObj)    // (from opcode)
    External (VRMS, FieldUnitObj)    // (from opcode)
    External (WDGN, FieldUnitObj)    // (from opcode)
    External (WDPE, FieldUnitObj)    // (from opcode)
    External (WDSA, FieldUnitObj)    // (from opcode)
    External (WDSS, FieldUnitObj)    // (from opcode)
    External (WDST, FieldUnitObj)    // (from opcode)
    External (XBAS, UnknownObj)    // (from opcode)

    Name (FEDC, Zero)
    Scope (\_SB.PCI0.RP01)
    {
        OperationRegion (RPCX, SystemMemory, Add (Add (\XBAS, ShiftLeft (ShiftRight (And (\_SB.PCI0.RP01._ADR (), 0x00FF0000), 0x10), 0x0F)), ShiftLeft (And (\RPA1, 0x0F), 0x0C)), 0x1000)
        Field (RPCX, DWordAcc, NoLock, Preserve)
        {
            PVID,   16, 
            PDID,   16, 
            CMDR,   8, 
            Offset (0x19), 
            PRBN,   8, 
            SCBN,   8, 
            Offset (0x4A), 
            CEDR,   1, 
            Offset (0x50), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1, 
            Offset (0x69), 
                ,   2, 
            LREN,   1, 
            Offset (0xA4), 
            D0D3,   2, 
            Offset (0x328), 
                ,   19, 
            LNKS,   4
        }

        Device (PEGA)
        {
            Method (_ADR, 0, NotSerialized)  // _ADR: Address
            {
                Return (One)
            }

            OperationRegion (ACAP, SystemMemory, Add (Add (\XBAS, ShiftLeft (\_SB.PCI0.RP01.PRBN, 0x14)), ShiftLeft (\_SB.PCI0.RP01.PEGA._ADR (), 0x0C)), 0x0160)
            Field (ACAP, DWordAcc, NoLock, Preserve)
            {
                AVID,   16, 
                ADID,   16, 
                CMDR,   8, 
                Offset (0x40), 
                SSID,   32, 
                Offset (0x15C), 
                SORR,   8
            }
        }

        PowerResource (PC09, 0x00, 0x0000)
        {
            Name (_STA, One)  // _STA: Status
            Method (_ON, 0, Serialized)  // _ON_: Power On
            {
                If (LNotEqual (OSYS, 0x07D9))
                {
                    If (LEqual (\_SB.PCI0.RP01.PXSX.TDGC, One))
                    {
                        If (LEqual (\_SB.PCI0.RP01.PXSX.DGCX, 0x03))
                        {
                            Store (One, _STA)
                            \_SB.PCI0.RP01.PXSX.GC6O ()
                        }
                        ElseIf (LEqual (\_SB.PCI0.RP01.PXSX.DGCX, 0x04))
                        {
                            Store (One, _STA)
                            \_SB.PCI0.RP01.PXSX.GC6O ()
                        }

                        Store (Zero, \_SB.PCI0.RP01.PXSX.TDGC)
                        Store (Zero, \_SB.PCI0.RP01.PXSX.DGCX)
                    }
                    Else
                    {
                        \_SB.PCI0.RP01.PXSX.HGON ()
                        Store (One, _STA)
                    }
                }
            }

            Method (_OFF, 0, Serialized)  // _OFF: Power Off
            {
                If (LNotEqual (OSYS, 0x07D9))
                {
                    If (LEqual (\_SB.PCI0.RP01.PXSX.TDGC, One))
                    {
                        CreateField (\_SB.PCI0.RP01.PXSX.TGPC, Zero, 0x03, GPCT)
                        If (LEqual (ToInteger (GPCT), One))
                        {
                            \_SB.PCI0.RP01.PXSX.GC6I ()
                            Store (Zero, _STA)
                        }
                        ElseIf (LEqual (ToInteger (GPCT), 0x02))
                        {
                            \_SB.PCI0.RP01.PXSX.GC6I ()
                            Store (Zero, _STA)
                        }
                    }
                    Else
                    {
                        \_SB.PCI0.RP01.PXSX.HGOF ()
                        Store (Zero, _STA)
                        Sleep (0x14)
                    }
                }
            }
        }

        Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
        {
            PC09
        })
        Name (_PR2, Package (0x01)  // _PR2: Power Resources for D2
        {
            PC09
        })
        Method (_PR3, 0, NotSerialized)  // _PR3: Power Resources for D3hot
        {
            Store (\_SB.PCI0.RP01.PXSX.LCTL, \_SB.PCI0.RP01.PXSX.ELCT)
            Store (\_SB.PCI0.RP01.PXSX.SVID, \_SB.PCI0.RP01.PXSX.HVID)
            Store (\_SB.PCI0.RP01.PXSX.SDID, \_SB.PCI0.RP01.PXSX.HDID)
            Return (Package (0x01)
            {
                PC09
            })
        }

        Method (_S0W, 0, NotSerialized)  // _S0W: S0 Device Wake State
        {
            Return (0x04)
        }
    }

    Scope (\_SB.PCI0.RP01.PXSX)
    {
        Name (IVID, 0xFFFF)
        Name (ELCT, Zero)
        Name (HVID, Zero)
        Name (HDID, Zero)
        Name (TCNT, Zero)
        Name (LDLY, 0x64)
        OperationRegion (PCIS, SystemMemory, Add (\XBAS, ShiftLeft (PRBN, 0x14)), 0xF0)
        Field (PCIS, AnyAcc, Lock, Preserve)
        {
            DVID,   16, 
            Offset (0x0B), 
            CBCC,   8, 
            Offset (0x2C), 
            SVID,   16, 
            SDID,   16
        }

        OperationRegion (PCAP, SystemMemory, Add (Add (\XBAS, ShiftLeft (PRBN, 0x14)), \EECP), 0x14)
        Field (PCAP, DWordAcc, NoLock, Preserve)
        {
            Offset (0x10), 
            LCTL,   16
        }

        Method (HGON, 0, Serialized)
        {
            If (LGreaterEqual (\GTOS (), 0x09))
            {
                Or (HGDG, 0x72000000, HGDG)
            }

            Or (HGDG, 0x04, HGDG)
            If (LEqual (CCHK (One), Zero))
            {
                Return (Zero)
            }

            SGPO (HRE0, HRG0, HRA0, One)
            SGPO (PWE0, PWG0, PWA0, One)
            Sleep (DLPW)
            SGPO (HRE0, HRG0, HRA0, Zero)
            Sleep (DLHR)
            Store (Zero, LNKD)
            Store (Zero, TCNT)
            While (LLess (TCNT, LDLY))
            {
                If (LGreaterEqual (LNKS, 0x07))
                {
                    Break
                }

                Sleep (0x10)
                Add (TCNT, 0x10, TCNT)
            }

            While (LLess (LNKS, 0x07))
            {
                Sleep (One)
            }

            If (LEqual (\_SB.PCI0.RP01.D0D3, 0x03))
            {
                Store (Zero, \_SB.PCI0.RP01.D0D3)
                Store (0x07, \_SB.PCI0.RP01.CMDR)
                Sleep (0x0A)
            }

            Store (HVID, Local1)
            Or (Local1, ShiftLeft (HDID, 0x10), Local1)
            Store (Local1, \_SB.PCI0.RP01.PXSX.SSID)
            Or (And (ELCT, 0x43), And (LCTL, 0xFFBC), LCTL)
            Store (\_SB.PCI0.RP01.PXSX.LTRE, \_SB.PCI0.RP01.LREN)
            Store (One, \_SB.PCI0.RP01.CEDR)
            \_SB.PCI0.RP01.PXSX.RDSS (One)
            If (LAnd (LEqual (\GTOS (), 0x0A), \_SB.PCI0.OPTF))
            {
                Store (One, \_SB.PCI0.RP01.PXSX.MLTF)
            }
            Else
            {
                Store (Zero, \_SB.PCI0.RP01.PXSX.MLTF)
                Store (Zero, \_SB.PCI0.OPTF)
            }

            If (LNotEqual (\_SB.PCI0.RP01.PEGA.AVID, 0xFFFF))
            {
                Store (NSOR, \_SB.PCI0.RP01.PEGA.SORR)
            }

            Or (HGDG, 0x08, HGDG)
            Return (Zero)
        }

        Method (_ON, 0, Serialized)  // _ON_: Power On
        {
            HGON ()
            Return (Zero)
        }

        Method (HGOF, 0, Serialized)
        {
            If (LGreaterEqual (\GTOS (), 0x09))
            {
                Or (HGD2, 0x82000000, HGD2)
            }

            Or (HGD2, 0x04, HGD2)
            If (LEqual (CCHK (Zero), Zero))
            {
                Return (Zero)
            }

            \_SB.PCI0.RP01.PXSX.RDSS (Zero)
            If (LNotEqual (DVID, 0xFFFF))
            {
                Store (LCTL, ELCT)
                Store (SVID, HVID)
                Store (SDID, HDID)
            }

            Store (\_SB.PCI0.RP01.LREN, \_SB.PCI0.RP01.PXSX.LTRE)
            Store (One, LNKD)
            Store (Zero, TCNT)
            While (LLess (TCNT, LDLY))
            {
                If (LEqual (LNKS, Zero))
                {
                    Break
                }

                Sleep (0x10)
                Add (TCNT, 0x10, TCNT)
            }

            SGPO (HRE0, HRG0, HRA0, One)
            SGPO (PWE0, PWG0, PWA0, Zero)
            Or (HGD2, 0x08, HGD2)
            Return (Zero)
        }

        Method (_OFF, 0, Serialized)  // _OFF: Power Off
        {
            HGOF ()
            Return (Zero)
        }

        Method (_STA, 0, Serialized)  // _STA: Status
        {
            Return (0x0F)
        }

        Method (SGPO, 4, Serialized)
        {
            If (LEqual (Arg2, Zero))
            {
                Not (Arg3, Arg3)
                And (Arg3, One, Arg3)
            }

            If (LEqual (SGGP, One))
            {
                If (CondRefOf (\_SB.SGOV))
                {
                    \_SB.SGOV (Arg1, Arg3)
                }
            }
        }

        Method (SGPI, 4, Serialized)
        {
            If (LEqual (Arg0, One))
            {
                If (CondRefOf (\_SB.GGOV))
                {
                    Store (\_SB.GGOV (Arg2), Local0)
                }
            }

            If (LEqual (Arg3, Zero))
            {
                Not (Local0, Local0)
                And (Local0, One, Local0)
            }

            Return (Local0)
        }

        Method (CCHK, 1, NotSerialized)
        {
            If (LEqual (PVID, IVID))
            {
                Return (Zero)
            }

            If (LEqual (Arg0, Zero))
            {
                If (LEqual (SGPI (SGGP, PWE0, PWG0, PWA0), Zero))
                {
                    Return (Zero)
                }
            }
            ElseIf (LEqual (Arg0, One))
            {
                If (LEqual (SGPI (SGGP, PWE0, PWG0, PWA0), One))
                {
                    Return (Zero)
                }
            }

            Return (One)
        }

        Method (SGIV, 4, Serialized)
        {
            If (LEqual (Arg0, One))
            {
                If (CondRefOf (\_SB.GGIV))
                {
                    Store (\_SB.GGIV (Arg2), Local0)
                }
            }

            If (LEqual (Arg3, Zero))
            {
                Not (Local0, Local0)
                And (Local0, One, Local0)
            }

            Return (Local0)
        }
    }

    Scope (\_SB)
    {
        Method (DGOR, 0, NotSerialized)
        {
            \_SB.PCI0.RP01.PXSX.SGPO (PWE0, PWG0, PWA0, One)
        }
    }

    Scope (\_SB.PCI0.RP01.PXSX)
    {
        Name (LTRE, Zero)
        OperationRegion (PCIA, SystemMemory, Add (\XBAS, ShiftLeft (PRBN, 0x14)), 0xF0)
        Field (PCIA, DWordAcc, Lock, Preserve)
        {
            VRID,   16, 
            DGID,   16, 
            Offset (0x40), 
            SSID,   32
        }

        Name (_S3D, 0x03)  // _S3D: S3 Device State
        Name (_S4D, 0x03)  // _S4D: S4 Device State
        Name (INIM, Zero)
        Name (DIDX, Package (0x09)
        {
            0x0110, 
            0x80000100, 
            0x80004210, 
            0x80006330, 
            0x80006320, 
            0x80006340, 
            0x80002330, 
            0x80002320, 
            0x80002340
        })
        Name (DIDC, Zero)
        Method (DIDM, 0, Serialized)
        {
            If (LEqual (DIDC, Zero))
            {
                Store (DEDP, Index (DODS, Zero))
                Store (SizeOf (DODS), Local1)
                Store (Zero, Local0)
                While (LLess (Local0, Local1))
                {
                    Store (DerefOf (Index (DODI, Local0)), Local2)
                    Store (DerefOf (Index (DODS, Local0)), Local3)
                    Store (Local3, Index (DIDX, Local2))
                    Increment (Local0)
                }

                Store (One, DIDC)
            }

            Return (DIDX)
        }

        Method (_DOD, 0, NotSerialized)  // _DOD: Display Output Devices
        {
            Return (NDOD ())
        }

        Method (_INI, 0, NotSerialized)  // _INI: Initialize
        {
            Store (One, INIM)
        }

        Method (_REG, 2, NotSerialized)  // _REG: Region Availability
        {
            If (LEqual (INIM, One))
            {
                Store (Zero, INIM)
            }

            If (CondRefOf (\_SB.PCI0.HGMD))
            {
                \_SB.PCI0.HGMD ()
            }
        }

        Scope (\_GPE)
        {
            Method (VHOV, 3, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                While (One)
                {
                    Store (ToInteger (Arg2), _T_0)
                    If (LEqual (_T_0, One))
                    {
                        If (And (Arg0, 0x80))
                        {
                            Notify (\_SB.PCI0.RP01.PXSX.LCD, Arg0)
                        }
                        ElseIf (LEqual (And (WDPE, 0x44), Zero))
                        {
                            \_SB.PCI0.RP01.PXSX.SBRV ()
                        }
                    }
                    ElseIf (LEqual (_T_0, 0x02))
                    {
                        \_SB.PCI0.RP01.PXSX.GDCC (One)
                        \_SB.PCI0.RP01.PXSX.DKET ()
                    }
                    ElseIf (LEqual (_T_0, 0x03))
                    {
                        \_SB.PCI0.RP01.PXSX.GLEV ()
                    }
                    ElseIf (LEqual (_T_0, 0x04))
                    {
                        If (LEqual (And (WDPE, 0x03), Zero))
                        {
                            \_SB.PCI0.RP01.PXSX.GF4E ()
                        }
                    }
                    ElseIf (LEqual (_T_0, 0x05))
                    {
                        \_SB.PCI0.RP01.PXSX.GPUP ()
                    }
                    ElseIf (LEqual (_T_0, 0x06))
                    {
                        If (And (DCAP, One))
                        {
                            \_SB.PCI0.RP01.PXSX.SNXS ()
                        }
                        Else
                        {
                            Notify (\_SB.PCI0.RP01.PXSX, 0x80)
                        }
                    }
                    ElseIf (LEqual (_T_0, 0x07))
                    {
                        \_SB.PCI0.RP01.PXSX.RFHS (Arg0)
                    }
                    ElseIf (LEqual (_T_0, 0x08))
                    {
                        \_SB.PCI0.RP01.PXSX.VWAK (Arg0)
                    }
                    ElseIf (LEqual (_T_0, 0x0A))
                    {
                        \_SB.ODGW (0xFF02)
                        \_SB.PCI0.RP01.PXSX.DGCE ()
                    }

                    Break
                }

                Return (Zero)
            }
        }

        Method (_DOS, 1, NotSerialized)  // _DOS: Disable Output Switching
        {
            And (WDPE, 0xF8, Local0)
            And (WDPE, 0x83, Local1)
            Or (Local0, Arg0, WDPE)
            If (CondRefOf (^PDOS, Local2))
            {
                ^PDOS (Arg0, Local1)
            }
        }

        Device (LCD)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (Zero))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                If (\_SB.LID._LID ())
                {
                    Return (DCS (Zero))
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (Zero))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (Zero, Arg0)
            }

            Method (_BCL, 0, Serialized)  // _BCL: Brightness Control Levels
            {
                If (LEqual (ILUX, One))
                {
                    Return (\_SB.BCL ())
                }
                ElseIf (LLessEqual (\GTOS (), 0x07))
                {
                    Return (\_SB.BCL ())
                }
                Else
                {
                    Return (Package (0x67)
                    {
                        0x50, 
                        0x32, 
                        Zero, 
                        One, 
                        0x02, 
                        0x03, 
                        0x04, 
                        0x05, 
                        0x06, 
                        0x07, 
                        0x08, 
                        0x09, 
                        0x0A, 
                        0x0B, 
                        0x0C, 
                        0x0D, 
                        0x0E, 
                        0x0F, 
                        0x10, 
                        0x11, 
                        0x12, 
                        0x13, 
                        0x14, 
                        0x15, 
                        0x16, 
                        0x17, 
                        0x18, 
                        0x19, 
                        0x1A, 
                        0x1B, 
                        0x1C, 
                        0x1D, 
                        0x1E, 
                        0x1F, 
                        0x20, 
                        0x21, 
                        0x22, 
                        0x23, 
                        0x24, 
                        0x25, 
                        0x26, 
                        0x27, 
                        0x28, 
                        0x29, 
                        0x2A, 
                        0x2B, 
                        0x2C, 
                        0x2D, 
                        0x2E, 
                        0x2F, 
                        0x30, 
                        0x31, 
                        0x32, 
                        0x33, 
                        0x34, 
                        0x35, 
                        0x36, 
                        0x37, 
                        0x38, 
                        0x39, 
                        0x3A, 
                        0x3B, 
                        0x3C, 
                        0x3D, 
                        0x3E, 
                        0x3F, 
                        0x40, 
                        0x41, 
                        0x42, 
                        0x43, 
                        0x45, 
                        0x45, 
                        0x46, 
                        0x47, 
                        0x48, 
                        0x49, 
                        0x4A, 
                        0x4B, 
                        0x4C, 
                        0x4D, 
                        0x4E, 
                        0x4F, 
                        0x50, 
                        0x51, 
                        0x52, 
                        0x53, 
                        0x54, 
                        0x55, 
                        0x56, 
                        0x57, 
                        0x58, 
                        0x59, 
                        0x5A, 
                        0x5B, 
                        0x5C, 
                        0x5D, 
                        0x5E, 
                        0x5F, 
                        0x60, 
                        0x61, 
                        0x62, 
                        0x63, 
                        0x64
                    })
                }
            }

            Method (_BCM, 1, Serialized)  // _BCM: Brightness Control Method
            {
                Store (\_SB.BCM (Arg0), Local0)
                If (Local0)
                {
                    If (LEqual (VACC, Zero))
                    {
                        If (LEqual (\_SB.PCI0.GFX0.ISBR (), Zero)) {}
                    }
                    ElseIf (LEqual (\_SB.PCI0.RP01.PXSX.SBRV (), Zero)) {}
                    Signal (\_SB.BEVT)
                }
            }

            Method (_BQC, 0, Serialized)  // _BQC: Brightness Query Current
            {
                Return (\_SB.BQC ())
            }
        }

        Device (CRT)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (One))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (One))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (One))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (One, Arg0)
            }
        }

        Device (TV)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x02))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x02))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x02))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x02, Arg0)
            }
        }

        Device (DVI)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x03))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x03))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x03))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x03, Arg0)
            }
        }

        Device (DD04)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x04))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x04))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x04))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x04, Arg0)
            }
        }

        Device (DD05)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x05))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x05))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x05))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x05, Arg0)
            }
        }

        Device (DD06)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x06))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x06))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x06))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x06, Arg0)
            }
        }

        Device (DD07)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x07))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x07))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x07))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x07, Arg0)
            }
        }

        Device (DD08)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x08))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x08))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x08))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x08, Arg0)
            }
        }

        Method (ADR, 1, Serialized)
        {
            Store (DIDM (), Local1)
            Store (SizeOf (Local1), Local2)
            If (LLess (Arg0, Local2))
            {
                Store (DerefOf (Index (Local1, Arg0)), Local0)
                If (LLess (\GTOS (), 0x06))
                {
                    And (Local0, 0xFFFF, Local0)
                }
            }
            Else
            {
                Store (Zero, Local0)
            }

            Return (Local0)
        }

        Method (DCS, 1, Serialized)
        {
            ShiftLeft (One, Arg0, Local1)
            Store (Zero, Local0)
            If (And (GDCC (Zero), Local1))
            {
                Store (One, Local0)
                If (And (WDST, Local1))
                {
                    Store (0x1D, Local0)
                    If (And (WDSA, Local1))
                    {
                        Store (0x1F, Local0)
                    }
                }
            }

            Return (Local0)
        }

        Method (DGS, 1, Serialized)
        {
            ShiftLeft (One, Arg0, Local2)
            Store (Zero, Local0)
            If (And (WDGN, Local2))
            {
                Store (One, Local0)
            }

            Return (Local0)
        }

        Method (DSS, 2, Serialized)
        {
            ShiftLeft (One, Arg0, Local1)
            Store (WDSS, Local0)
            If (And (Arg1, One))
            {
                Or (Local0, Local1, Local0)
            }
            Else
            {
                And (Local0, Not (Local1), Local0)
            }

            Store (Local0, WDSS)
            If (And (Arg1, 0x40000000))
            {
                Store (Local0, WDSA)
            }
        }

        Method (RDSS, 1, Serialized)
        {
            If (\_SB.PCI0.LPCB.EC0.ECRG)
            {
                Acquire (\_SB.PCI0.LPCB.EC0.ECMX, 0xFFFF)
                If (LEqual (Arg0, One))
                {
                    If (LEqual (VRID, 0x1002))
                    {
                        Store (0x03, \_SB.PCI0.LPCB.EC0.TENA)
                    }
                    ElseIf (LEqual (VRID, 0x10DE))
                    {
                        Store (0x05, \_SB.PCI0.LPCB.EC0.TENA)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.LPCB.EC0.TENA)
                    }
                }
                Else
                {
                    Store (One, \_SB.PCI0.LPCB.EC0.TENA)
                }

                Release (\_SB.PCI0.LPCB.EC0.ECMX)
            }
        }

        Scope (\_SB.PCI0)
        {
            Name (OTM, "OTMACPI 2010-Mar-09 12:08:26")
        }

        Scope (\_SB.PCI0.RP01.PXSX)
        {
            Name (VGAB, Buffer (0xFB)
            {
                 0x00                                           
            })
            Name (GPRF, Zero)
            Name (OMPR, 0x02)
            Name (DGOS, Zero)
            Name (SORV, Zero)
            OperationRegion (PCNV, SystemMemory, Add (\XBAS, ShiftLeft (\_SB.PCI0.RP01.PRBN, 0x14)), 0x0670)
            Field (PCNV, AnyAcc, NoLock, Preserve)
            {
                Offset (0x04), 
                CMDR,   8, 
                VGAR,   2008, 
                Offset (0x488), 
                HDAR,   16, 
                    ,   9, 
                MLTF,   1
            }

            Method (_PS0, 0, NotSerialized)  // _PS0: Power State 0
            {
                Store (0x71000000, HGDG)
                If (DGOS)
                {
                    Or (HGDG, One, HGDG)
                    \_SB.PCI0.RP01.PXSX._ON ()
                    If (LNotEqual (GPRF, One))
                    {
                        Store (VGAB, VGAR)
                    }

                    Store (Zero, DGOS)
                    Or (HGDG, 0x10, HGDG)
                }
            }

            Method (_PS3, 0, NotSerialized)  // _PS3: Power State 3
            {
                Store (0x81000000, HGD2)
                If (LEqual (\_SB.PCI0.RP01.PXSX.OMPR, 0x03))
                {
                    If (LNotEqual (GPRF, One))
                    {
                        Store (VGAR, VGAB)
                    }

                    Or (HGD2, One, HGD2)
                    \_SB.PCI0.RP01.PXSX._OFF ()
                    Sleep (0x64)
                    Store (One, DGOS)
                    Store (0x02, \_SB.PCI0.RP01.PXSX.OMPR)
                    Or (HGD2, 0x10, HGD2)
                }
            }
        }

        Scope (\_SB.PCI0.RP01.PXSX)
        {
            Method (GOBT, 1, NotSerialized)
            {
                Name (OPVK, Buffer (0xE2)
                {
                    /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0010 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0018 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0020 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0028 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0030 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0038 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0040 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0048 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0050 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0058 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0060 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0068 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0070 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0078 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0080 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0088 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0090 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0098 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 00A0 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 00A8 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 00B0 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 00B8 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 00C0 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 00C8 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 00D0 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 00D8 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 00E0 */  0x00, 0x00                                     
                })
                CreateWordField (Arg0, 0x02, USRG)
                If (LEqual (USRG, 0x564B))
                {
                    Return (OPVK)
                }

                Return (Zero)
            }
        }

        Scope (\_SB.PCI0.RP01.PXSX)
        {
            Method (NVOP, 4, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                If (LNotEqual (Arg1, 0x0100))
                {
                    Return (0x80000002)
                }

                While (One)
                {
                    Store (ToInteger (Arg2), _T_0)
                    If (LEqual (_T_0, Zero))
                    {
                        Store (Buffer (0x04)
                            {
                                 0x00, 0x00, 0x00, 0x00                         
                            }, Local0)
                        Divide (Zero, 0x08, Local2, Local1)
                        ShiftLeft (One, Local2, Local2)
                        Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                        Divide (0x1A, 0x08, Local2, Local1)
                        ShiftLeft (One, Local2, Local2)
                        Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                        Divide (0x10, 0x08, Local2, Local1)
                        ShiftLeft (One, Local2, Local2)
                        Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                        Return (Local0)
                    }
                    ElseIf (LEqual (_T_0, 0x05)) {}
                    ElseIf (LEqual (_T_0, 0x06)) {}
                    ElseIf (LEqual (_T_0, 0x1A))
                    {
                        CreateField (Arg3, 0x18, 0x02, OPCE)
                        CreateField (Arg3, Zero, One, FLCH)
                        CreateField (Arg3, One, One, DVSR)
                        CreateField (Arg3, 0x02, One, DVSC)
                        If (ToInteger (FLCH))
                        {
                            Store (OPCE, OMPR)
                        }

                        Store (Buffer (0x04)
                            {
                                 0x00, 0x00, 0x00, 0x00                         
                            }, Local0)
                        CreateField (Local0, Zero, One, OPEN)
                        CreateField (Local0, 0x03, 0x02, CGCS)
                        CreateField (Local0, 0x06, One, SHPC)
                        CreateField (Local0, 0x08, One, SNSR)
                        CreateField (Local0, 0x18, 0x03, DGPC)
                        CreateField (Local0, 0x1B, 0x02, HDAC)
                        Store (One, OPEN)
                        Store (One, SHPC)
                        Store (0x02, HDAC)
                        Store (One, DGPC)
                        If (ToInteger (DVSC))
                        {
                            If (ToInteger (DVSR))
                            {
                                Store (One, GPRF)
                            }
                            Else
                            {
                                Store (Zero, GPRF)
                            }
                        }

                        Store (GPRF, SNSR)
                        If (\_SB.PCI0.RP01.PXSX.GSTA ())
                        {
                            Store (0x03, CGCS)
                        }
                        Else
                        {
                            Store (Zero, CGCS)
                        }

                        Return (Local0)
                    }
                    ElseIf (LEqual (_T_0, 0x1B))
                    {
                        Store (Arg3, Local0)
                        CreateField (Local0, Zero, One, OPFL)
                        CreateField (Local0, One, One, OPVL)
                        If (ToInteger (OPVL))
                        {
                            Store (Zero, \_SB.PCI0.OPTF)
                            If (ToInteger (OPFL))
                            {
                                Store (One, \_SB.PCI0.OPTF)
                                Store (NSOR, \_SB.PCI0.RP01.PEGA.SORR)
                            }
                            Else
                            {
                            }
                        }

                        Store (\_SB.PCI0.OPTF, Local0)
                        Return (Local0)
                    }
                    ElseIf (LEqual (_T_0, 0x10))
                    {
                        Return (\_SB.PCI0.RP01.PXSX.GOBT (Arg3))
                    }

                    Break
                }

                Return (0x80000002)
            }
        }

        Name (PSBR, Zero)
        Name (BRIN, Zero)
        Name (TGIX, One)
        Name (MUID, ToUUID ("4004a400-917d-4cf2-b89c-79b62fd55665"))
        Name (NUID, ToUUID ("d4a50b75-65c7-46f7-bfb7-41514cea0244"))
        Name (VUID, ToUUID ("a486d8f8-0bda-471b-a72b-6042a6b5bee0"))
        Name (GSID, ToUUID ("a3132d01-8cda-49ba-a52e-bc9d46df6b81"))
        Name (GC6U, ToUUID ("cbeca351-067b-4924-9cbd-b46b00b86f34"))
        Name (BLHD, Package (0x0A)
        {
            Zero, 
            0x02, 
            Zero, 
            Zero, 
            0x04, 
            One, 
            0x05DC, 
            Zero, 
            0x03E8, 
            Zero
        })
        Scope (\_SB.PCI0)
        {
            OperationRegion (RTCO, SystemIO, 0x72, 0x02)
            Field (RTCO, ByteAcc, NoLock, Preserve)
            {
                RTIN,   8, 
                RTDA,   8
            }

            IndexField (RTIN, RTDA, ByteAcc, NoLock, Preserve)
            {
                Offset (0x7D), 
                OPTF,   1
            }
        }

        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (LEqual (\SRCP (Arg0, MUID), One))
            {
                If (CondRefOf (\_SB.PCI0.RP01.PXSX.MDSM))
                {
                    Return (MDSM (Arg0, Arg1, Arg2, Arg3))
                }
            }

            If (LEqual (\SRCP (Arg0, NUID), One))
            {
                Return (NDSM (Arg0, Arg1, Arg2, Arg3))
            }

            If (LEqual (\SRCP (Arg0, VUID), One))
            {
                If (CondRefOf (\_SB.PCI0.RP01.PXSX.NVOP))
                {
                    Return (NVOP (Arg0, Arg1, Arg2, Arg3))
                }
            }

            If (LEqual (\SRCP (Arg0, GSID), One))
            {
                Return (GPS (Arg0, Arg1, Arg2, Arg3))
            }

            If (LEqual (\SRCP (Arg0, GC6U), One))
            {
                If (CondRefOf (\_SB.PCI0.RP01.PXSX.NVJT))
                {
                    Return (NVJT (Arg0, Arg1, Arg2, Arg3))
                }
            }

            Return (0x80000002)
        }

        Method (NDSM, 4, Serialized)
        {
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            If (LNotEqual (Arg1, 0x0102))
            {
                Return (0x80000002)
            }

            Store (Buffer (0x04)
                {
                     0x00, 0x00, 0x00, 0x00                         
                }, Local0)
            CreateDWordField (Local0, Zero, NVRD)
            While (One)
            {
                Store (ToInteger (Arg2), _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Store (0x00180063, NVRD)
                    If (LGreater (\GTOS (), 0x05))
                    {
                        Or (WDPE, 0x40, WDPE)
                    }

                    Or (DCAP, 0x07, DCAP)
                    Return (Local0)
                }
                ElseIf (LEqual (_T_0, One))
                {
                    Store (0x0250, NVRD)
                    Return (Local0)
                }
                ElseIf (LEqual (_T_0, 0x05))
                {
                    CreateDWordField (Arg3, Zero, ARGX)
                    CreateBitField (Arg3, 0x18, DMSK)
                    CreateField (Arg3, 0x19, 0x05, NCSN)
                    CreateBitField (Arg3, 0x1F, NCSM)
                    CreateField (Local0, 0x08, 0x06, TLSN)
                    If (NCSM)
                    {
                        Store (NCSN, TGIX)
                    }

                    If (DMSK)
                    {
                        And (ARGX, 0x03FF, Local1)
                        Store (TOHP (Local1), WDST)
                        ShiftRight (ARGX, 0x0C, Local1)
                        And (Local1, 0x03FF, Local1)
                        Store (TOHP (Local1), WDSA)
                        If (LEqual (WDSA, One))
                        {
                            Or (WDST, One, WDGN)
                            If (LEqual (WDGN, One))
                            {
                                Store (One, TGIX)
                            }
                            Else
                            {
                                Store (0x02, TGIX)
                            }
                        }
                        ElseIf (And (WDSA, One))
                        {
                            If (LEqual (TGIX, 0x02))
                            {
                                Store (WDST, WDGN)
                                Store (0x03, TGIX)
                            }
                            Else
                            {
                                And (WDST, 0xFFFFFFFE, WDGN)
                                Store (0x04, TGIX)
                            }
                        }
                        Else
                        {
                            Store (One, WDGN)
                            Store (One, TGIX)
                        }

                        If (And (PSBR, One))
                        {
                            Signal (\_SB.F4EV)
                            And (PSBR, 0xFFFFFFFE, PSBR)
                        }
                    }

                    Store (TGIX, TLSN)
                    If (And (PSBR, 0x04))
                    {
                        And (PSBR, 0xFFFFFFFB, PSBR)
                    }

                    If (\_SB.DCKD ())
                    {
                        Or (NVRD, 0x20, NVRD)
                    }

                    If (And (PSBR, 0x02))
                    {
                        And (PSBR, 0xFFFFFFFD, PSBR)
                    }

                    If (BRIN)
                    {
                        SBRV ()
                        Store (Zero, BRIN)
                    }

                    Return (Local0)
                }
                ElseIf (LEqual (_T_0, 0x06))
                {
                    If (LEqual (DerefOf (Index (MDTL, Zero)), Zero))
                    {
                        Store (_DOD (), Local1)
                        Store (SizeOf (Local1), Local0)
                        Increment (Local0)
                        Store (DerefOf (Index (Local1, Zero)), Index (MDTL, Zero))
                        Store (0x2C, Index (MDTL, One))
                        Store (Zero, Local5)
                        Store (0x02, Local2)
                        Add (Local2, Local0, Local3)
                        Add (Local3, Local0, Local4)
                        While (LLess (Local5, Subtract (Local0, One)))
                        {
                            Store (DerefOf (Index (Local1, Local5)), Local6)
                            Store (Local6, Index (MDTL, Local2))
                            Increment (Local2)
                            Store (Local6, Index (MDTL, Local3))
                            Increment (Local3)
                            If (LGreater (Local5, Zero))
                            {
                                Store (Local6, Index (MDTL, Local4))
                                Increment (Local4)
                            }

                            Increment (Local5)
                        }

                        Store (0x26, Index (MDTL, Local2))
                        Store (0x2B, Index (MDTL, Local3))
                        Store (0x2B, Index (MDTL, Local4))
                    }

                    Return (MDTL)
                }
                ElseIf (LEqual (_T_0, 0x13))
                {
                    \_SB.ODGW (0xC007)
                    CreateDWordField (Arg3, Zero, ARGY)
                    \_SB.ODGW (ARGY)
                    Store (0x04, NVRD)
                    \_SB.ODGW (0xC008)
                    Return (NVRD)
                }
                ElseIf (LEqual (_T_0, 0x14))
                {
                    If (LEqual (\BCCT, 0x15))
                    {
                        Store (Package (0x34) {}, Local7)
                    }
                    Else
                    {
                        Store (Package (0x20) {}, Local7)
                    }

                    Store (Zero, Local0)
                    Subtract (SizeOf (BLHD), One, Local2)
                    While (LLess (Local0, Local2))
                    {
                        Store (DerefOf (Index (BLHD, Local0)), Index (Local7, Local0))
                        Increment (Local0)
                    }

                    Store (\BCCT, Index (Local7, Local0))
                    Store (_DOD (), Local1)
                    Store (DerefOf (Index (Local1, Zero)), Local2)
                    Store (Local2, Index (Local7, Zero))
                    If (LLess (\GTOS (), 0x06))
                    {
                        Store (0x0100, Index (Local7, One))
                    }

                    If (LGreater (\GTOS (), 0x06))
                    {
                        Store (0x0200, Index (Local7, One))
                    }

                    Store (BRLV, Local5)
                    Store (BCLV, Local6)
                    Store (Zero, Local0)
                    While (LLess (Local0, \BCCT))
                    {
                        Add (Local0, SizeOf (BLHD), Local2)
                        Store (DerefOf (Index (Local5, Local0)), Local1)
                        Multiply (Local1, 0x03E8, Local3)
                        Divide (Add (Local3, 0x7F), 0xFF, Local4, Local1)
                        Store (Local1, Index (Local7, Local2))
                        Add (Local2, \BCCT, Local2)
                        Store (DerefOf (Index (Local6, Add (Local0, 0x02))), Local1)
                        Multiply (Local1, 0x0A, Index (Local7, Local2))
                        Increment (Local0)
                    }

                    Return (Local7)
                }

                Break
            }

            Return (0x80000002)
        }

        Method (DKET, 0, Serialized)
        {
            Or (PSBR, 0x04, PSBR)
            Notify (^, 0x81)
            Return (One)
        }

        Method (GF4E, 0, Serialized)
        {
            Or (PSBR, One, PSBR)
            Notify (^, 0x80)
            Return (One)
        }

        Method (GLEV, 0, Serialized)
        {
            Or (PSBR, 0x02, PSBR)
            Notify (^, 0xDB)
        }

        Method (GPUP, 0, Serialized)
        {
            Store (0xD3, Local0)
            If (LEqual (\_SB.PCI0.LPCB.EC0.GACS (), One))
            {
                If (LEqual (\_SB.PCI0.LPCB.EC0.GPID (), Zero))
                {
                    Store (0xD1, Local0)
                }
                Else
                {
                    Store (0xD2, Local0)
                }
            }

            Notify (^, Local0)
            Return (One)
        }

        Method (SBRV, 0, Serialized)
        {
            Store (\_SB.SBRC (), Local1)
            If (APBX (0x02))
            {
                If (PBIA ())
                {
                    Multiply (Local1, 0x03E8, Local2)
                    Divide (Local2, 0xFF, Local3, Local1)
                    ShiftLeft (Local1, 0x08, PBDI)
                    SPBC (0x86100000)
                }

                RPBX (0x02)
            }

            Return (One)
        }

        Method (RFHS, 1, Serialized)
        {
            Wait (\_SB.F4EV, 0x0500)
        }

        Method (SNXS, 0, Serialized)
        {
            Return (Zero)
        }

        Method (VWAK, 1, Serialized)
        {
            If (LGreaterEqual (Arg0, 0x03))
            {
                If (LEqual (And (WDPE, 0x44), Zero))
                {
                    \_SB.ODGW (0xD5F2)
                    Store (One, BRIN)
                }
            }
        }

        Method (TOHP, 1, Serialized)
        {
            Store (DODI, Local1)
            Store (SizeOf (Local1), Local3)
            Store (Zero, Local0)
            Store (Arg0, Local7)
            Store (Zero, Local2)
            While (LAnd (LLess (Local0, Local3), Local7))
            {
                ShiftLeft (One, Local0, Local4)
                If (And (Local7, Local4))
                {
                    Store (DerefOf (Index (Local1, Local0)), Local5)
                    ShiftLeft (One, Local5, Local6)
                    Or (Local2, Local6, Local2)
                }

                And (Local7, Not (Local4), Local7)
                Increment (Local0)
            }

            Return (Local2)
        }

        Method (DGCE, 0, Serialized)
        {
            Return (Zero)
        }

        OperationRegion (GPPB, PCI_Config, 0xB4, 0x14)
        Field (GPPB, ByteAcc, NoLock, Preserve)
        {
            PBCI,   8, 
            PBNP,   8, 
            PBLS,   8, 
            PBCC,   8, 
            PBCR,   32, 
            PBDI,   32, 
            PBDO,   32, 
            PBMX,   32
        }

        Method (APBX, 1, Serialized)
        {
            Store (Zero, Local1)
            If (And (PBCC, One))
            {
                Store (0x28, Local0)
                While (LGreater (Local0, Zero))
                {
                    While (LAnd (LNotEqual (PBMX, Zero), LGreater (Local0, Zero)))
                    {
                        Sleep (0x32)
                        Decrement (Local0)
                    }

                    If (LEqual (PBMX, Zero))
                    {
                        Store (Arg0, PBMX)
                        If (LEqual (PBMX, Arg0))
                        {
                            Store (One, Local1)
                            Break
                        }
                    }
                }
            }

            Return (Local1)
        }

        Method (RPBX, 1, Serialized)
        {
            Store (0x14, Local0)
            While (LAnd (LEqual (PBMX, Arg0), LGreater (Local0, Zero)))
            {
                Store (Zero, PBMX)
                Decrement (Local0)
            }
        }

        Method (PBIA, 0, Serialized)
        {
            Store (0x0A, Local0)
            While (LAnd (And (PBCR, 0x02), LGreater (Local0, Zero)))
            {
                Sleep (One)
                Decrement (Local0)
            }

            If (And (PBCR, 0x02))
            {
                Store (Zero, Local1)
            }
            Else
            {
                Store (One, Local1)
            }

            Return (Local1)
        }

        Method (SPBC, 1, Serialized)
        {
            Store (Arg0, PBCR)
        }

        Scope (\_SB.PCI0.RP01.PXSX)
        {
            OperationRegion (REVD, SystemMemory, VRMB, VRMS)
            Field (REVD, AnyAcc, NoLock, Preserve)
            {
                SROM,   32, 
                VROM,   1277952
            }
        }

        Scope (\_SB.PCI0.RP01.PXSX)
        {
            Method (_ROM, 2, NotSerialized)  // _ROM: Read-Only Memory
            {
                Add (VRMB, 0x04, Local0)
                Add (Local0, Arg0, Local0)
                Subtract (VRMS, 0x04, Local1)
                If (CondRefOf (\_SB.PCI0.RP01.PXSX.LNHV))
                {
                    Store (\_SB.PCI0.RP01.PXSX.LNHV (), Local2)
                    If (LNotEqual (DerefOf (Index (Local2, Zero)), Zero))
                    {
                        Store (DerefOf (Index (Local2, Zero)), Local0)
                        Add (Local0, Arg0, Local0)
                        Store (DerefOf (Index (Local2, One)), Local1)
                    }
                }

                If (LLess (Arg0, Local1))
                {
                    OperationRegion (OROM, SystemMemory, Local0, 0x1000)
                    Field (OROM, AnyAcc, NoLock, Preserve)
                    {
                        R4KB,   32768
                    }

                    Return (R4KB)
                }
                Else
                {
                    Store (Buffer (One)
                        {
                             0x00                                           
                        }, Local0)
                    Return (Local0)
                }
            }
        }

        Name (GESC, Zero)
        Name (RPPC, Zero)
        Name (GSTS, Zero)
        Name (DEVT, Zero)
        Name (FBDX, Zero)
        Scope (\_SB.PCI0.RP01.PXSX)
        {
            Method (RNPL, 0, NotSerialized)
            {
                Store (Zero, \_SB.PCI0.RP01.PXSX.DEVT)
            }

            Method (NPD5, 0, NotSerialized)
            {
                If (LEqual (\_SB.PCI0.RP01.PXSX.DEVT, One))
                {
                    Notify (\_SB.PCI0.RP01.PXSX, 0xD5)
                    Store (0xD5, NDXN)
                }
            }

            Method (NPLU, 0, NotSerialized)
            {
                If (CondRefOf (\_SB.PCI0.RP01.PXSX.NPLH))
                {
                    If (LEqual (\_SB.PCI0.RP01.PXSX.DEVT, One))
                    {
                        \_SB.PCI0.RP01.PXSX.NPLH ()
                    }
                }
                ElseIf (LEqual (\_SB.PCI0.LPCB.EC0.ADP, One))
                {
                    If (LEqual (\_SB.PCI0.RP01.PXSX.DEVT, One))
                    {
                        Notify (\_SB.PCI0.RP01.PXSX, 0xD1)
                        Store (0xD1, NDXN)
                    }
                }
                ElseIf (LEqual (\_SB.PCI0.RP01.PXSX.DEVT, One))
                {
                    Notify (\_SB.PCI0.RP01.PXSX, 0xD4)
                    Store (0xD4, NDXN)
                }
            }
        }

        Scope (\_SB.PCI0.RP01.PXSX)
        {
            Method (GPS, 4, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                If (LNotEqual (Arg1, 0x0100))
                {
                    Return (0x80000002)
                }

                While (One)
                {
                    Store (ToInteger (Arg2), _T_0)
                    If (LEqual (_T_0, Zero))
                    {
                        Store (Buffer (0x08)
                            {
                                 0x01, 0x00, 0x08, 0x00, 0x0F, 0x04, 0x00, 0x00 
                            }, Local0)
                        Return (Local0)
                    }
                    ElseIf (LEqual (_T_0, 0x13))
                    {
                        If (LEqual (FBDX, One))
                        {
                            Store (0x02, FBDX)
                            If (CondRefOf (\_SB.PCI0.LPCB.EC0.UDTS))
                            {
                                \_SB.PCI0.LPCB.EC0.UDTS ()
                            }
                        }

                        CreateByteField (Arg3, Zero, TEMP)
                        If (LEqual (TEMP, Zero))
                        {
                            Return (0x04)
                        }

                        And (TEMP, 0x0F, TEMP)
                        If (LEqual (TEMP, 0x04))
                        {
                            Store (Zero, \_SB.PCI0.LPCB.EC0.EXTP)
                            Return (Arg3)
                        }
                    }
                    ElseIf (LEqual (_T_0, 0x20))
                    {
                        CreateBitField (Arg3, 0x18, NRIT)
                        CreateBitField (Arg3, 0x19, RITS)
                        CreateField (Arg3, 0x1A, 0x03, PSTS)
                        CreateBitField (Arg3, 0x1D, NPSS)
                        CreateBitField (Arg3, 0x1E, PSES)
                        Name (GB32, Buffer (0x04)
                        {
                             0x00                                           
                        })
                        CreateBitField (GB32, Zero, SPLU)
                        CreateBitField (GB32, One, PSLS)
                        CreateBitField (GB32, 0x17, CCES)
                        CreateBitField (GB32, 0x18, CITS)
                        CreateBitField (GB32, 0x1E, PSER)
                        If (RITS)
                        {
                            If (NRIT)
                            {
                                Store (One, CITS)
                            }
                            Else
                            {
                                Store (Zero, CITS)
                            }
                        }

                        Store (One, CITS)
                        Store (One, PSER)
                        If (GESC)
                        {
                            Store (One, SPLU)
                        }

                        Store (Zero, CCES)
                        If (LNotEqual (\_PR.HWPV, Zero))
                        {
                            Store (One, CCES)
                        }

                        Return (GB32)
                    }
                    ElseIf (LEqual (_T_0, 0x21))
                    {
                        If (CondRefOf (\_PR.PR00._PSS))
                        {
                            Return (\_PR.PR00._PSS ())
                        }
                        Else
                        {
                            Return (Package (0x02)
                            {
                                Package (0x06)
                                {
                                    Zero, 
                                    Zero, 
                                    Zero, 
                                    Zero, 
                                    Zero, 
                                    Zero
                                }, 

                                Package (0x06)
                                {
                                    Zero, 
                                    Zero, 
                                    Zero, 
                                    Zero, 
                                    Zero, 
                                    Zero
                                }
                            })
                        }
                    }
                    ElseIf (LEqual (_T_0, 0x22))
                    {
                        CreateByteField (Arg3, Zero, PCAP)
                        Store (PCAP, RPPC)
                        Store (PCAP, \_PR.CPPC)
                        PNOT ()
                        Return (Zero)
                    }
                    ElseIf (LEqual (_T_0, 0x23))
                    {
                        Store (\_PR.PR00._PPC, RPPC)
                        Return (RPPC)
                    }
                    ElseIf (LEqual (_T_0, 0x2A))
                    {
                        CreateByteField (Arg3, Zero, QUTP)
                        CreateBitField (Arg3, 0x08, GPUT)
                        CreateBitField (Arg3, 0x09, CPUT)
                        CreateBitField (Arg3, 0x0A, FANS)
                        CreateBitField (Arg3, 0x0B, SKIN)
                        CreateBitField (Arg3, 0x0C, CENG)
                        CreateBitField (Arg3, 0x0D, SEN1)
                        CreateBitField (Arg3, 0x0E, SEN2)
                        Name (GB42, Buffer (0x24)
                        {
                             0x00                                           
                        })
                        CreateDWordField (GB42, Zero, STSV)
                        CreateDWordField (GB42, 0x04, VERS)
                        CreateDWordField (GB42, 0x08, TGPU)
                        CreateDWordField (GB42, 0x0C, PDTS)
                        CreateDWordField (GB42, 0x10, SFAN)
                        CreateDWordField (GB42, 0x14, SKNT)
                        CreateDWordField (GB42, 0x18, CPUE)
                        CreateDWordField (GB42, 0x1C, TMP1)
                        CreateDWordField (GB42, 0x20, TMP2)
                        While (One)
                        {
                            If (LEqual (QUTP, Zero))
                            {
                                If (CPUT)
                                {
                                    Store (0x0200, STSV)
                                    Or (STSV, QUTP, STSV)
                                    Acquire (\_SB.PCI0.LPCB.EC0.ECMX, 0xFFFF)
                                    Store (One, \_SB.PCI0.LPCB.EC0.CRZN)
                                    Store (\_SB.PCI0.LPCB.EC0.DTMP, PDTS)
                                    Release (\_SB.PCI0.LPCB.EC0.ECMX)
                                }

                                Return (GB42)
                            }
                            ElseIf (LEqual (QUTP, One))
                            {
                                Store (0x0300, STSV)
                                Or (STSV, QUTP, STSV)
                                Store (0x03E8, PDTS)
                                Return (GB42)
                            }
                            ElseIf (LEqual (QUTP, 0x02))
                            {
                                Store (0x0102, STSV)
                                Or (STSV, QUTP, STSV)
                                Store (Zero, VERS)
                                Store (Zero, TGPU)
                                Store (Zero, PDTS)
                                Store (Zero, SFAN)
                                Store (Zero, SKNT)
                                Store (Zero, CPUE)
                                Store (Zero, TMP1)
                                Store (Zero, TMP2)
                                Return (GB42)
                            }

                            Break
                        }
                    }
                    ElseIf (LEqual (_T_0, 0x33))
                    {
                        Notify (\_SB.PCI0.RP01.PXSX, 0xC0)
                    }

                    Break
                }

                Return (0x80000002)
            }
        }

        Scope (\_SB.PCI0.RP01.PXSX)
        {
            Name (TGPC, Buffer (0x04)
            {
                 0x00                                           
            })
            Name (TDGC, Zero)
            Name (DGCX, Zero)
            Name (TRPC, Zero)
            Method (GC6I, 0, Serialized)
            {
                \_SB.PCI0.RP01.PXSX.RDSS (Zero)
                Store (\_SB.PCI0.RP01.LREN, \_SB.PCI0.RP01.PXSX.LTRE)
                Sleep (0x0A)
                Store (One, \_SB.PCI0.RP01.LNKD)
                While (LNotEqual (SGIV (One, GC6E, GC6G, GC6A), One))
                {
                    Sleep (One)
                }

                Sleep (0x10)
            }

            Method (GC6O, 0, Serialized)
            {
                Store (Zero, \_SB.PCI0.RP01.LNKD)
                SGPO (GETE, GETG, GETA, One)
                While (LNotEqual (SGIV (One, GC6E, GC6G, GC6A), Zero))
                {
                    Sleep (One)
                }

                SGPO (GETE, GETG, GETA, Zero)
                While (LLess (\_SB.PCI0.RP01.LNKS, 0x07))
                {
                    Sleep (One)
                }

                Store (\_SB.PCI0.RP01.PXSX.LTRE, \_SB.PCI0.RP01.LREN)
                Store (One, \_SB.PCI0.RP01.CEDR)
                Sleep (0x0A)
                \_SB.PCI0.RP01.PXSX.RDSS (One)
            }

            Method (GETS, 0, Serialized)
            {
                If (LEqual (SGIV (One, GC6E, GC6G, GC6A), Zero))
                {
                    Return (One)
                }
                Else
                {
                    Return (0x03)
                }
            }
        }

        Scope (\_SB.PCI0.RP01.PXSX)
        {
            Method (NVJT, 4, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                If (LGreater (Arg1, 0x0103))
                {
                    Return (0x80000002)
                }

                While (One)
                {
                    Store (ToInteger (Arg2), _T_0)
                    If (LEqual (_T_0, Zero))
                    {
                        Store (Buffer (0x04)
                            {
                                 0x1B, 0x00, 0x00, 0x00                         
                            }, Local0)
                        Return (Local0)
                    }
                    ElseIf (LEqual (_T_0, One))
                    {
                        Name (JTB1, Buffer (0x04)
                        {
                             0x00                                           
                        })
                        CreateField (JTB1, Zero, One, JTEN)
                        CreateField (JTB1, One, 0x02, SREN)
                        CreateField (JTB1, 0x03, 0x02, PLPR)
                        CreateField (JTB1, 0x05, One, SRPR)
                        CreateField (JTB1, 0x06, 0x02, FBPR)
                        CreateField (JTB1, 0x08, 0x02, GUPR)
                        CreateField (JTB1, 0x0A, One, GC6R)
                        CreateField (JTB1, 0x0B, One, PTRH)
                        CreateField (JTB1, 0x0D, One, MHYB)
                        CreateField (JTB1, 0x0E, One, RPCL)
                        CreateField (JTB1, 0x0F, 0x02, GC6M)
                        CreateField (JTB1, 0x14, 0x0C, JTRV)
                        Store (One, JTEN)
                        Store (One, GC6R)
                        Store (One, MHYB)
                        Store (One, RPCL)
                        If (LEqual (ToInteger (RPCL), One))
                        {
                            Store (One, TRPC)
                        }

                        Store (One, PTRH)
                        Store (One, GC6M)
                        Store (One, SREN)
                        If (LEqual (\_SB.PCI0.GFX0.GVID, 0xFFFF))
                        {
                            Store (0x02, PLPR)
                            Store (Zero, SRPR)
                        }

                        Store (0x0103, JTRV)
                        Return (JTB1)
                    }
                    ElseIf (LEqual (_T_0, 0x02))
                    {
                        Return (0x80000002)
                    }
                    ElseIf (LEqual (_T_0, 0x03))
                    {
                        CreateField (Arg3, Zero, 0x03, NVPC)
                        CreateField (Arg3, 0x04, One, PLPC)
                        CreateField (Arg3, 0x0E, 0x02, DFGC)
                        CreateField (Arg3, 0x10, 0x03, GPCX)
                        Store (Arg3, TGPC)
                        If (LOr (LNotEqual (ToInteger (NVPC), Zero), LNotEqual (ToInteger (DFGC), Zero)))
                        {
                            Store (ToInteger (DFGC), TDGC)
                            Store (ToInteger (GPCX), DGCX)
                        }

                        Name (JTB3, Buffer (0x04)
                        {
                             0x00                                           
                        })
                        CreateField (JTB3, Zero, 0x03, GUPS)
                        CreateField (JTB3, 0x03, One, GPGS)
                        CreateField (JTB3, 0x07, One, PLST)
                        If (LNotEqual (ToInteger (DFGC), Zero))
                        {
                            Store (One, GPGS)
                            Store (One, GUPS)
                            Return (JTB3)
                        }

                        If (LEqual (ToInteger (NVPC), One))
                        {
                            GC6I ()
                            Store (One, PLST)
                            Store (Zero, GUPS)
                        }
                        ElseIf (LEqual (ToInteger (NVPC), 0x02))
                        {
                            GC6I ()
                            If (LEqual (ToInteger (PLPC), Zero))
                            {
                                Store (Zero, PLST)
                            }

                            Store (Zero, GUPS)
                        }
                        ElseIf (LEqual (ToInteger (NVPC), 0x03))
                        {
                            GC6O ()
                            If (LNotEqual (ToInteger (PLPC), Zero))
                            {
                                Store (Zero, PLST)
                            }

                            Store (One, GPGS)
                            Store (Zero, GUPS)
                        }
                        ElseIf (LEqual (ToInteger (NVPC), 0x04))
                        {
                            GC6O ()
                            If (LNotEqual (ToInteger (PLPC), Zero))
                            {
                                Store (Zero, PLST)
                            }

                            Store (One, GPGS)
                            Store (Zero, GUPS)
                        }
                        ElseIf (LEqual (ToInteger (NVPC), Zero))
                        {
                            Store (GETS (), GUPS)
                            If (LEqual (ToInteger (GUPS), One))
                            {
                                Store (One, GPGS)
                            }
                            Else
                            {
                                Store (Zero, GPGS)
                            }
                        }
                        ElseIf (LEqual (ToInteger (NVPC), 0x06)) {}
                        Return (JTB3)
                    }
                    ElseIf (LEqual (_T_0, 0x04))
                    {
                        Store (Arg3, Local0)
                        CreateField (Local0, 0x02, One, AAUD)
                        CreateField (Local0, 0x03, One, AADM)
                        If (ToInteger (AADM))
                        {
                            Store (Zero, \_SB.PCI0.OPTF)
                            If (ToInteger (AAUD))
                            {
                                Store (One, \_SB.PCI0.OPTF)
                                Store (NSOR, \_SB.PCI0.RP01.PEGA.SORR)
                            }
                            Else
                            {
                            }
                        }

                        ShiftLeft (\_SB.PCI0.OPTF, 0x02, Local0)
                        Return (Local0)
                    }

                    Break
                }

                Return (0x80000002)
            }
        }

        Scope (\_SB.PCI0.RP01.PXSX)
        {
            Method (LKE7, 0, Serialized)
            {
            }

            Method (LKD7, 0, Serialized)
            {
            }
        }

        Method (GSTA, 0, Serialized)
        {
            If (LEqual (SGPI (SGGP, PWE0, PWG0, PWA0), One))
            {
                Return (One)
            }
            Else
            {
                Return (Zero)
            }
        }

        Method (FEDP, 0, Serialized)
        {
            If (LEqual (FEDC, Zero))
            {
                Store (One, Local5)
                Store (SizeOf (DODS), Local0)
                While (LLess (Local5, Local0))
                {
                    Store (DerefOf (Index (DODS, Local5)), Index (DODS, Subtract (Local5, One)))
                    Increment (Local5)
                }

                Store (Zero, Index (DODS, Subtract (Local5, One)))
                Store (One, FEDC)
            }
        }
    }
}

